/**
 * POCDMT000040ClinicalDocument.java
 *
 * File generated from the cdaepsos3::POCDMT000040ClinicalDocument uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaepsos3;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.util.ArrayList;
import java.util.List;

// End of user code


/**
 * Description of the class POCDMT000040ClinicalDocument.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.ClinicalDocument", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"id",
	"code",
	"title",
	"effectiveTime",
	"confidentialityCode",
	"languageCode",
	"setId",
	"versionNumber",
	"copyTime",
	"recordTarget",
	"author",
	"dataEnterer",
	"informant",
	"custodian",
	"informationRecipient",
	"legalAuthenticator",
	"authenticator",
	"participant",
	"inFulfillmentOf",
	"documentationOf",
	"relatedDocument",
	"authorization",
	"componentOf",
	"component",
	"classCode",
	"moodCode",
	"nullFlavor"
})
@XmlRootElement(name = "ClinicalDocument")
public class POCDMT000040ClinicalDocument implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", required = true, namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> templateId;
	@XmlElement(name = "id", required = true, namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.II id;
	@XmlElement(name = "code", required = true, namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE code;
	@XmlElement(name = "title", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.ST title;
	@XmlElement(name = "effectiveTime", required = true, namespace = "urn:hl7-org:v3")
	public TSEPSOSTZ effectiveTime;
	@XmlElement(name = "confidentialityCode", required = true, namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE confidentialityCode;
	@XmlElement(name = "languageCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CS languageCode;
	@XmlElement(name = "setId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.II setId;
	@XmlElement(name = "versionNumber", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.INT versionNumber;
	@XmlElement(name = "copyTime", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.TS copyTime;
	@XmlElement(name = "recordTarget", required = true, namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040RecordTarget> recordTarget;
	@XmlElement(name = "author", required = true, namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Author> author;
	@XmlElement(name = "dataEnterer", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040DataEnterer dataEnterer;
	@XmlElement(name = "informant", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12> informant;
	@XmlElement(name = "custodian", required = true, namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040Custodian custodian;
	@XmlElement(name = "informationRecipient", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040InformationRecipient> informationRecipient;
	@XmlElement(name = "legalAuthenticator", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040LegalAuthenticator legalAuthenticator;
	@XmlElement(name = "authenticator", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Authenticator> authenticator;
	@XmlElement(name = "participant", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Participant1> participant;
	@XmlElement(name = "inFulfillmentOf", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040InFulfillmentOf> inFulfillmentOf;
	@XmlElement(name = "documentationOf", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040DocumentationOf> documentationOf;
	@XmlElement(name = "relatedDocument", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040RelatedDocument> relatedDocument;
	@XmlElement(name = "authorization", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Authorization> authorization;
	@XmlElement(name = "componentOf", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040Component1 componentOf;
	@XmlElement(name = "component", required = true, namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040Component2 component;
	@XmlAttribute(name = "classCode")
	public net.ihe.gazelle.voc.ActClinicalDocument classCode;
	@XmlAttribute(name = "moodCode")
	public net.ihe.gazelle.voc.ActMood moodCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}
	
	/**
	 * Return id.
	 * @return id
	 */
	public net.ihe.gazelle.datatypes.II getId() {
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(net.ihe.gazelle.datatypes.II id) {
	    this.id = id;
	}
	
	
	
	
	/**
	 * Return code.
	 * @return code
	 */
	public net.ihe.gazelle.datatypes.CE getCode() {
	    return code;
	}
	
	/**
	 * Set a value to attribute code.
	 * @param code.
	 */
	public void setCode(net.ihe.gazelle.datatypes.CE code) {
	    this.code = code;
	}
	
	
	
	
	/**
	 * Return title.
	 * @return title
	 */
	public net.ihe.gazelle.datatypes.ST getTitle() {
	    return title;
	}
	
	/**
	 * Set a value to attribute title.
	 * @param title.
	 */
	public void setTitle(net.ihe.gazelle.datatypes.ST title) {
	    this.title = title;
	}
	
	
	
	
	/**
	 * Return effectiveTime.
	 * @return effectiveTime
	 */
	public TSEPSOSTZ getEffectiveTime() {
	    return effectiveTime;
	}
	
	/**
	 * Set a value to attribute effectiveTime.
	 * @param effectiveTime.
	 */
	public void setEffectiveTime(TSEPSOSTZ effectiveTime) {
	    this.effectiveTime = effectiveTime;
	}
	
	
	
	
	/**
	 * Return confidentialityCode.
	 * @return confidentialityCode
	 */
	public net.ihe.gazelle.datatypes.CE getConfidentialityCode() {
	    return confidentialityCode;
	}
	
	/**
	 * Set a value to attribute confidentialityCode.
	 * @param confidentialityCode.
	 */
	public void setConfidentialityCode(net.ihe.gazelle.datatypes.CE confidentialityCode) {
	    this.confidentialityCode = confidentialityCode;
	}
	
	
	
	
	/**
	 * Return languageCode.
	 * @return languageCode
	 */
	public net.ihe.gazelle.datatypes.CS getLanguageCode() {
	    return languageCode;
	}
	
	/**
	 * Set a value to attribute languageCode.
	 * @param languageCode.
	 */
	public void setLanguageCode(net.ihe.gazelle.datatypes.CS languageCode) {
	    this.languageCode = languageCode;
	}
	
	
	
	
	/**
	 * Return setId.
	 * @return setId
	 */
	public net.ihe.gazelle.datatypes.II getSetId() {
	    return setId;
	}
	
	/**
	 * Set a value to attribute setId.
	 * @param setId.
	 */
	public void setSetId(net.ihe.gazelle.datatypes.II setId) {
	    this.setId = setId;
	}
	
	
	
	
	/**
	 * Return versionNumber.
	 * @return versionNumber
	 */
	public net.ihe.gazelle.datatypes.INT getVersionNumber() {
	    return versionNumber;
	}
	
	/**
	 * Set a value to attribute versionNumber.
	 * @param versionNumber.
	 */
	public void setVersionNumber(net.ihe.gazelle.datatypes.INT versionNumber) {
	    this.versionNumber = versionNumber;
	}
	
	
	
	
	/**
	 * Return copyTime.
	 * @return copyTime
	 */
	public net.ihe.gazelle.datatypes.TS getCopyTime() {
	    return copyTime;
	}
	
	/**
	 * Set a value to attribute copyTime.
	 * @param copyTime.
	 */
	public void setCopyTime(net.ihe.gazelle.datatypes.TS copyTime) {
	    this.copyTime = copyTime;
	}
	
	
	
	
	/**
	 * Return recordTarget.
	 * @return recordTarget
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040RecordTarget> getRecordTarget() {
		if (recordTarget == null) {
	        recordTarget = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040RecordTarget>();
	    }
	    return recordTarget;
	}
	
	/**
	 * Set a value to attribute recordTarget.
	 * @param recordTarget.
	 */
	public void setRecordTarget(List<net.ihe.gazelle.cdaepsos3.POCDMT000040RecordTarget> recordTarget) {
	    this.recordTarget = recordTarget;
	}
	
	
	
	/**
	 * Add a recordTarget to the recordTarget collection.
	 * @param recordTarget_elt Element to add.
	 */
	public void addRecordTarget(net.ihe.gazelle.cdaepsos3.POCDMT000040RecordTarget recordTarget_elt) {
	    this.getRecordTarget().add(recordTarget_elt);
	}
	
	/**
	 * Remove a recordTarget to the recordTarget collection.
	 * @param recordTarget_elt Element to remove
	 */
	public void removeRecordTarget(net.ihe.gazelle.cdaepsos3.POCDMT000040RecordTarget recordTarget_elt) {
	    this.getRecordTarget().remove(recordTarget_elt);
	}
	
	/**
	 * Return author.
	 * @return author
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Author> getAuthor() {
		if (author == null) {
	        author = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040Author>();
	    }
	    return author;
	}
	
	/**
	 * Set a value to attribute author.
	 * @param author.
	 */
	public void setAuthor(List<net.ihe.gazelle.cdaepsos3.POCDMT000040Author> author) {
	    this.author = author;
	}
	
	
	
	/**
	 * Add a author to the author collection.
	 * @param author_elt Element to add.
	 */
	public void addAuthor(net.ihe.gazelle.cdaepsos3.POCDMT000040Author author_elt) {
	    this.getAuthor().add(author_elt);
	}
	
	/**
	 * Remove a author to the author collection.
	 * @param author_elt Element to remove
	 */
	public void removeAuthor(net.ihe.gazelle.cdaepsos3.POCDMT000040Author author_elt) {
	    this.getAuthor().remove(author_elt);
	}
	
	/**
	 * Return dataEnterer.
	 * @return dataEnterer
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040DataEnterer getDataEnterer() {
	    return dataEnterer;
	}
	
	/**
	 * Set a value to attribute dataEnterer.
	 * @param dataEnterer.
	 */
	public void setDataEnterer(net.ihe.gazelle.cdaepsos3.POCDMT000040DataEnterer dataEnterer) {
	    this.dataEnterer = dataEnterer;
	}
	
	
	
	
	/**
	 * Return informant.
	 * @return informant
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12> getInformant() {
		if (informant == null) {
	        informant = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12>();
	    }
	    return informant;
	}
	
	/**
	 * Set a value to attribute informant.
	 * @param informant.
	 */
	public void setInformant(List<net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12> informant) {
	    this.informant = informant;
	}
	
	
	
	/**
	 * Add a informant to the informant collection.
	 * @param informant_elt Element to add.
	 */
	public void addInformant(net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12 informant_elt) {
	    this.getInformant().add(informant_elt);
	}
	
	/**
	 * Remove a informant to the informant collection.
	 * @param informant_elt Element to remove
	 */
	public void removeInformant(net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12 informant_elt) {
	    this.getInformant().remove(informant_elt);
	}
	
	/**
	 * Return custodian.
	 * @return custodian
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040Custodian getCustodian() {
	    return custodian;
	}
	
	/**
	 * Set a value to attribute custodian.
	 * @param custodian.
	 */
	public void setCustodian(net.ihe.gazelle.cdaepsos3.POCDMT000040Custodian custodian) {
	    this.custodian = custodian;
	}
	
	
	
	
	/**
	 * Return informationRecipient.
	 * @return informationRecipient
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040InformationRecipient> getInformationRecipient() {
		if (informationRecipient == null) {
	        informationRecipient = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040InformationRecipient>();
	    }
	    return informationRecipient;
	}
	
	/**
	 * Set a value to attribute informationRecipient.
	 * @param informationRecipient.
	 */
	public void setInformationRecipient(List<net.ihe.gazelle.cdaepsos3.POCDMT000040InformationRecipient> informationRecipient) {
	    this.informationRecipient = informationRecipient;
	}
	
	
	
	/**
	 * Add a informationRecipient to the informationRecipient collection.
	 * @param informationRecipient_elt Element to add.
	 */
	public void addInformationRecipient(net.ihe.gazelle.cdaepsos3.POCDMT000040InformationRecipient informationRecipient_elt) {
	    this.getInformationRecipient().add(informationRecipient_elt);
	}
	
	/**
	 * Remove a informationRecipient to the informationRecipient collection.
	 * @param informationRecipient_elt Element to remove
	 */
	public void removeInformationRecipient(net.ihe.gazelle.cdaepsos3.POCDMT000040InformationRecipient informationRecipient_elt) {
	    this.getInformationRecipient().remove(informationRecipient_elt);
	}
	
	/**
	 * Return legalAuthenticator.
	 * @return legalAuthenticator
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040LegalAuthenticator getLegalAuthenticator() {
	    return legalAuthenticator;
	}
	
	/**
	 * Set a value to attribute legalAuthenticator.
	 * @param legalAuthenticator.
	 */
	public void setLegalAuthenticator(net.ihe.gazelle.cdaepsos3.POCDMT000040LegalAuthenticator legalAuthenticator) {
	    this.legalAuthenticator = legalAuthenticator;
	}
	
	
	
	
	/**
	 * Return authenticator.
	 * @return authenticator
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Authenticator> getAuthenticator() {
		if (authenticator == null) {
	        authenticator = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040Authenticator>();
	    }
	    return authenticator;
	}
	
	/**
	 * Set a value to attribute authenticator.
	 * @param authenticator.
	 */
	public void setAuthenticator(List<net.ihe.gazelle.cdaepsos3.POCDMT000040Authenticator> authenticator) {
	    this.authenticator = authenticator;
	}
	
	
	
	/**
	 * Add a authenticator to the authenticator collection.
	 * @param authenticator_elt Element to add.
	 */
	public void addAuthenticator(net.ihe.gazelle.cdaepsos3.POCDMT000040Authenticator authenticator_elt) {
	    this.getAuthenticator().add(authenticator_elt);
	}
	
	/**
	 * Remove a authenticator to the authenticator collection.
	 * @param authenticator_elt Element to remove
	 */
	public void removeAuthenticator(net.ihe.gazelle.cdaepsos3.POCDMT000040Authenticator authenticator_elt) {
	    this.getAuthenticator().remove(authenticator_elt);
	}
	
	/**
	 * Return participant.
	 * @return participant
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Participant1> getParticipant() {
		if (participant == null) {
	        participant = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040Participant1>();
	    }
	    return participant;
	}
	
	/**
	 * Set a value to attribute participant.
	 * @param participant.
	 */
	public void setParticipant(List<net.ihe.gazelle.cdaepsos3.POCDMT000040Participant1> participant) {
	    this.participant = participant;
	}
	
	
	
	/**
	 * Add a participant to the participant collection.
	 * @param participant_elt Element to add.
	 */
	public void addParticipant(net.ihe.gazelle.cdaepsos3.POCDMT000040Participant1 participant_elt) {
	    this.getParticipant().add(participant_elt);
	}
	
	/**
	 * Remove a participant to the participant collection.
	 * @param participant_elt Element to remove
	 */
	public void removeParticipant(net.ihe.gazelle.cdaepsos3.POCDMT000040Participant1 participant_elt) {
	    this.getParticipant().remove(participant_elt);
	}
	
	/**
	 * Return inFulfillmentOf.
	 * @return inFulfillmentOf
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040InFulfillmentOf> getInFulfillmentOf() {
		if (inFulfillmentOf == null) {
	        inFulfillmentOf = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040InFulfillmentOf>();
	    }
	    return inFulfillmentOf;
	}
	
	/**
	 * Set a value to attribute inFulfillmentOf.
	 * @param inFulfillmentOf.
	 */
	public void setInFulfillmentOf(List<net.ihe.gazelle.cdaepsos3.POCDMT000040InFulfillmentOf> inFulfillmentOf) {
	    this.inFulfillmentOf = inFulfillmentOf;
	}
	
	
	
	/**
	 * Add a inFulfillmentOf to the inFulfillmentOf collection.
	 * @param inFulfillmentOf_elt Element to add.
	 */
	public void addInFulfillmentOf(net.ihe.gazelle.cdaepsos3.POCDMT000040InFulfillmentOf inFulfillmentOf_elt) {
	    this.getInFulfillmentOf().add(inFulfillmentOf_elt);
	}
	
	/**
	 * Remove a inFulfillmentOf to the inFulfillmentOf collection.
	 * @param inFulfillmentOf_elt Element to remove
	 */
	public void removeInFulfillmentOf(net.ihe.gazelle.cdaepsos3.POCDMT000040InFulfillmentOf inFulfillmentOf_elt) {
	    this.getInFulfillmentOf().remove(inFulfillmentOf_elt);
	}
	
	/**
	 * Return documentationOf.
	 * @return documentationOf
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040DocumentationOf> getDocumentationOf() {
		if (documentationOf == null) {
	        documentationOf = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040DocumentationOf>();
	    }
	    return documentationOf;
	}
	
	/**
	 * Set a value to attribute documentationOf.
	 * @param documentationOf.
	 */
	public void setDocumentationOf(List<net.ihe.gazelle.cdaepsos3.POCDMT000040DocumentationOf> documentationOf) {
	    this.documentationOf = documentationOf;
	}
	
	
	
	/**
	 * Add a documentationOf to the documentationOf collection.
	 * @param documentationOf_elt Element to add.
	 */
	public void addDocumentationOf(net.ihe.gazelle.cdaepsos3.POCDMT000040DocumentationOf documentationOf_elt) {
	    this.getDocumentationOf().add(documentationOf_elt);
	}
	
	/**
	 * Remove a documentationOf to the documentationOf collection.
	 * @param documentationOf_elt Element to remove
	 */
	public void removeDocumentationOf(net.ihe.gazelle.cdaepsos3.POCDMT000040DocumentationOf documentationOf_elt) {
	    this.getDocumentationOf().remove(documentationOf_elt);
	}
	
	/**
	 * Return relatedDocument.
	 * @return relatedDocument
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040RelatedDocument> getRelatedDocument() {
		if (relatedDocument == null) {
	        relatedDocument = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040RelatedDocument>();
	    }
	    return relatedDocument;
	}
	
	/**
	 * Set a value to attribute relatedDocument.
	 * @param relatedDocument.
	 */
	public void setRelatedDocument(List<net.ihe.gazelle.cdaepsos3.POCDMT000040RelatedDocument> relatedDocument) {
	    this.relatedDocument = relatedDocument;
	}
	
	
	
	/**
	 * Add a relatedDocument to the relatedDocument collection.
	 * @param relatedDocument_elt Element to add.
	 */
	public void addRelatedDocument(net.ihe.gazelle.cdaepsos3.POCDMT000040RelatedDocument relatedDocument_elt) {
	    this.getRelatedDocument().add(relatedDocument_elt);
	}
	
	/**
	 * Remove a relatedDocument to the relatedDocument collection.
	 * @param relatedDocument_elt Element to remove
	 */
	public void removeRelatedDocument(net.ihe.gazelle.cdaepsos3.POCDMT000040RelatedDocument relatedDocument_elt) {
	    this.getRelatedDocument().remove(relatedDocument_elt);
	}
	
	/**
	 * Return authorization.
	 * @return authorization
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Authorization> getAuthorization() {
		if (authorization == null) {
	        authorization = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040Authorization>();
	    }
	    return authorization;
	}
	
	/**
	 * Set a value to attribute authorization.
	 * @param authorization.
	 */
	public void setAuthorization(List<net.ihe.gazelle.cdaepsos3.POCDMT000040Authorization> authorization) {
	    this.authorization = authorization;
	}
	
	
	
	/**
	 * Add a authorization to the authorization collection.
	 * @param authorization_elt Element to add.
	 */
	public void addAuthorization(net.ihe.gazelle.cdaepsos3.POCDMT000040Authorization authorization_elt) {
	    this.getAuthorization().add(authorization_elt);
	}
	
	/**
	 * Remove a authorization to the authorization collection.
	 * @param authorization_elt Element to remove
	 */
	public void removeAuthorization(net.ihe.gazelle.cdaepsos3.POCDMT000040Authorization authorization_elt) {
	    this.getAuthorization().remove(authorization_elt);
	}
	
	/**
	 * Return componentOf.
	 * @return componentOf
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040Component1 getComponentOf() {
	    return componentOf;
	}
	
	/**
	 * Set a value to attribute componentOf.
	 * @param componentOf.
	 */
	public void setComponentOf(net.ihe.gazelle.cdaepsos3.POCDMT000040Component1 componentOf) {
	    this.componentOf = componentOf;
	}
	
	
	
	
	/**
	 * Return component.
	 * @return component
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040Component2 getComponent() {
	    return component;
	}
	
	/**
	 * Set a value to attribute component.
	 * @param component.
	 */
	public void setComponent(net.ihe.gazelle.cdaepsos3.POCDMT000040Component2 component) {
	    this.component = component;
	}
	
	
	
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.voc.ActClinicalDocument getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.voc.ActClinicalDocument classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return moodCode.
	 * @return moodCode
	 */
	public net.ihe.gazelle.voc.ActMood getMoodCode() {
	    return moodCode;
	}
	
	/**
	 * Set a value to attribute moodCode.
	 * @param moodCode.
	 */
	public void setMoodCode(net.ihe.gazelle.voc.ActMood moodCode) {
	    this.moodCode = moodCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaepsos3");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "ClinicalDocument").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	/**
	* method validateByXPATHV2
	*
	*/
	public boolean validateByXPATHV2(String xpath){
		Boolean res = false;
		org.w3c.dom.Node _xmlNode = this.get_xmlNodePresentation();
		try {
			res = net.ihe.gazelle.gen.common.XpathUtils.evaluateByNode(_xmlNode, xpath);
		} catch (Exception e) {
			res = false;
		}
		return res;
	}
	
	
		

	/**
	 * Description of the method getAllSections.
	 *
	 * @return ret
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Section> getAllSections() {
		List<POCDMT000040Section> res = new ArrayList<POCDMT000040Section>();
			if (this.getComponent() != null && this.getComponent().getStructuredBody() != null){
				for (POCDMT000040Component3 comp : this.getComponent().getStructuredBody().getComponent()) {
					if (comp.getSection() != null){
						res.add(comp.getSection());
						res.addAll(comp.getSection().getAllSections());
					}
				}
			}
			return res;
	}
		

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040ClinicalDocument pOCDMT000040ClinicalDocument, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040ClinicalDocument != null){
   			cvm.validate(pOCDMT000040ClinicalDocument, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: pOCDMT000040ClinicalDocument.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040ClinicalDocument.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II templateId: pOCDMT000040ClinicalDocument.getTemplateId()){
					net.ihe.gazelle.datatypes.II.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.datatypes.II.validateByModule(pOCDMT000040ClinicalDocument.getId(), _location + "/id", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040ClinicalDocument.getCode(), _location + "/code", cvm, diagnostic);
			net.ihe.gazelle.datatypes.ST.validateByModule(pOCDMT000040ClinicalDocument.getTitle(), _location + "/title", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos3.TSEPSOSTZ.validateByModule(pOCDMT000040ClinicalDocument.getEffectiveTime(), _location + "/effectiveTime", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040ClinicalDocument.getConfidentialityCode(), _location + "/confidentialityCode", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CS.validateByModule(pOCDMT000040ClinicalDocument.getLanguageCode(), _location + "/languageCode", cvm, diagnostic);
			net.ihe.gazelle.datatypes.II.validateByModule(pOCDMT000040ClinicalDocument.getSetId(), _location + "/setId", cvm, diagnostic);
			net.ihe.gazelle.datatypes.INT.validateByModule(pOCDMT000040ClinicalDocument.getVersionNumber(), _location + "/versionNumber", cvm, diagnostic);
			net.ihe.gazelle.datatypes.TS.validateByModule(pOCDMT000040ClinicalDocument.getCopyTime(), _location + "/copyTime", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040RecordTarget recordTarget: pOCDMT000040ClinicalDocument.getRecordTarget()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040RecordTarget.validateByModule(recordTarget, _location + "/recordTarget[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040Author author: pOCDMT000040ClinicalDocument.getAuthor()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040Author.validateByModule(author, _location + "/author[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			net.ihe.gazelle.cdaepsos3.POCDMT000040DataEnterer.validateByModule(pOCDMT000040ClinicalDocument.getDataEnterer(), _location + "/dataEnterer", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12 informant: pOCDMT000040ClinicalDocument.getInformant()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12.validateByModule(informant, _location + "/informant[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			net.ihe.gazelle.cdaepsos3.POCDMT000040Custodian.validateByModule(pOCDMT000040ClinicalDocument.getCustodian(), _location + "/custodian", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040InformationRecipient informationRecipient: pOCDMT000040ClinicalDocument.getInformationRecipient()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040InformationRecipient.validateByModule(informationRecipient, _location + "/informationRecipient[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			net.ihe.gazelle.cdaepsos3.POCDMT000040LegalAuthenticator.validateByModule(pOCDMT000040ClinicalDocument.getLegalAuthenticator(), _location + "/legalAuthenticator", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040Authenticator authenticator: pOCDMT000040ClinicalDocument.getAuthenticator()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040Authenticator.validateByModule(authenticator, _location + "/authenticator[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040Participant1 participant: pOCDMT000040ClinicalDocument.getParticipant()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040Participant1.validateByModule(participant, _location + "/participant[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040InFulfillmentOf inFulfillmentOf: pOCDMT000040ClinicalDocument.getInFulfillmentOf()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040InFulfillmentOf.validateByModule(inFulfillmentOf, _location + "/inFulfillmentOf[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040DocumentationOf documentationOf: pOCDMT000040ClinicalDocument.getDocumentationOf()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040DocumentationOf.validateByModule(documentationOf, _location + "/documentationOf[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040RelatedDocument relatedDocument: pOCDMT000040ClinicalDocument.getRelatedDocument()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040RelatedDocument.validateByModule(relatedDocument, _location + "/relatedDocument[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040Authorization authorization: pOCDMT000040ClinicalDocument.getAuthorization()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040Authorization.validateByModule(authorization, _location + "/authorization[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			net.ihe.gazelle.cdaepsos3.POCDMT000040Component1.validateByModule(pOCDMT000040ClinicalDocument.getComponentOf(), _location + "/componentOf", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos3.POCDMT000040Component2.validateByModule(pOCDMT000040ClinicalDocument.getComponent(), _location + "/component", cvm, diagnostic);
    	}
    }

}